package model

import (
	"github.com/zeromicro/go-zero/core/stores/cache"
	"github.com/zeromicro/go-zero/core/stores/sqlx"
)

var _ UserTableModel = (*customUserTableModel)(nil)

type (
	// UserTableModel is an interface to be customized, add more methods here,
	// and implement the added methods in customUserTableModel.
	UserTableModel interface {
		userTableModel
	}

	customUserTableModel struct {
		*defaultUserTableModel
	}
)

// NewUserTableModel returns a model for the database table.
func NewUserTableModel(conn sqlx.SqlConn, c cache.CacheConf, opts ...cache.Option) UserTableModel {
	return &customUserTableModel{
		defaultUserTableModel: newUserTableModel(conn, c, opts...),
	}
}
