// Code generated by goctl. DO NOT EDIT.
// Source: member.proto

package server

import (
	"context"

	"member/gen_result/pb/member"
	"member/internal/logic"
	"member/internal/svc"
)

type AccountServer struct {
	svcCtx *svc.ServiceContext
	member.UnimplementedAccountServer
}

func NewAccountServer(svcCtx *svc.ServiceContext) *AccountServer {
	return &AccountServer{
		svcCtx: svcCtx,
	}
}

// CreateUserAccount 建立帳號與密碼 -> 可登入，但可不可以做其他事情看業務流程，也可以只註冊就好
func (s *AccountServer) CreateUserAccount(ctx context.Context, in *member.CreateLoginUserReq) (*member.Response, error) {
	l := logic.NewCreateUserAccountLogic(ctx, s.svcCtx)
	return l.CreateUserAccount(in)
}

// GetUserAccountInfo 取得帳號密碼資料
func (s *AccountServer) GetUserAccountInfo(ctx context.Context, in *member.GetUIDByAccountReq) (*member.GetAccountInfoResp, error) {
	l := logic.NewGetUserAccountInfoLogic(ctx, s.svcCtx)
	return l.GetUserAccountInfo(in)
}

// UpdateUserToken 更新密碼
func (s *AccountServer) UpdateUserToken(ctx context.Context, in *member.UpdateTokenReq) (*member.Response, error) {
	l := logic.NewUpdateUserTokenLogic(ctx, s.svcCtx)
	return l.UpdateUserToken(in)
}

// GetUidByAccount 用帳號換取 UID
func (s *AccountServer) GetUidByAccount(ctx context.Context, in *member.GetUIDByAccountReq) (*member.GetUidByAccountResp, error) {
	l := logic.NewGetUidByAccountLogic(ctx, s.svcCtx)
	return l.GetUidByAccount(in)
}

// BindAccount 綁定帳號 -> account bind to UID
func (s *AccountServer) BindAccount(ctx context.Context, in *member.BindingUserReq) (*member.Response, error) {
	l := logic.NewBindAccountLogic(ctx, s.svcCtx)
	return l.BindAccount(in)
}

// BindUserInfo 初次，綁定 User Info
func (s *AccountServer) BindUserInfo(ctx context.Context, in *member.CreateUserInfoReq) (*member.Response, error) {
	l := logic.NewBindUserInfoLogic(ctx, s.svcCtx)
	return l.BindUserInfo(in)
}

// UpdateUserInfo 更新 User Info
func (s *AccountServer) UpdateUserInfo(ctx context.Context, in *member.UpdateUserInfoReq) (*member.Response, error) {
	l := logic.NewUpdateUserInfoLogic(ctx, s.svcCtx)
	return l.UpdateUserInfo(in)
}

// UpdateStatus 修改狀態
func (s *AccountServer) UpdateStatus(ctx context.Context, in *member.UpdateStatusReq) (*member.Response, error) {
	l := logic.NewUpdateStatusLogic(ctx, s.svcCtx)
	return l.UpdateStatus(in)
}

// UpdateStatus 取得會員資訊
func (s *AccountServer) GetUserInfo(ctx context.Context, in *member.GetUserInfoReq) (*member.GetUserInfoResp, error) {
	l := logic.NewGetUserInfoLogic(ctx, s.svcCtx)
	return l.GetUserInfo(in)
}

// ListMember 取得會員列表
func (s *AccountServer) ListMember(ctx context.Context, in *member.ListUserInfoReq) (*member.ListUserInfoResp, error) {
	l := logic.NewListMemberLogic(ctx, s.svcCtx)
	return l.ListMember(in)
}

// GenerateRefreshCode 這個帳號驗證碼（十分鐘），通用的
func (s *AccountServer) GenerateRefreshCode(ctx context.Context, in *member.GenerateRefreshCodeReq) (*member.GenerateRefreshCodeResp, error) {
	l := logic.NewGenerateRefreshCodeLogic(ctx, s.svcCtx)
	return l.GenerateRefreshCode(in)
}

// VerifyRefreshCode 驗證忘記密碼 token
func (s *AccountServer) VerifyRefreshCode(ctx context.Context, in *member.VerifyRefreshCodeReq) (*member.Response, error) {
	l := logic.NewVerifyRefreshCodeLogic(ctx, s.svcCtx)
	return l.VerifyRefreshCode(in)
}
